/*++
normalf -- returns normal form of p modulo polynomials in list S

normalf(p, S, [,o])

p   - polynomial
S   - list of polynomials (ideal)
o   - optional term ordering (LexOrder, DegInvLexOrder or DegreeOrder,
		or some function)


'DegInvLexOrder' is used if the order is not given.
++*/

groebner::normalf:=
proc(p, S, oo=DegInvLexOrder)
begin
  divide(p, op(S), oo, Rem);
end_proc:

// end of file 
