//    

// kg, 05/09/95 

/*--
generate.mu -- define/load functions generating foreign formats
--*/

generate:= newDomain("generate"):
generate::create_dom:=hold(generate):
generate::info:= "Library 'generate': generate foreign formats from expressions":
generate::interface:= {hold(TeX), hold(C), hold(fortran),
                       hold(optimize), hold(MathML), hold(MATLAB), hold(Simscape)}:
generate::notrace = {hold(sortSum), hold(sortSums), hold(sortExprWithDOrDiff)}:

alias(path = pathname("GENERATE")):

generate::MathML       := loadproc(generate::MathML,       path, "MathML"):
generate::TeX          := loadproc(generate::TeX,          path, "TeX"):
generate::ifTeXmacs    := loadproc(generate::ifTeXmacs,    path, "TeX"):
generate::whitespaceBeforeFractions := 
                          loadproc(generate::whitespaceBeforeFractions, path, "TeX"):
generate::TeXdef       := loadproc(generate::TeXdef,       path, "TeX"):
generate::C            := loadproc(generate::C,            path, "C"):
generate::fortran      := loadproc(generate::fortran,      path, "fortran"):
generate::MATLAB       := loadproc(generate::MATLAB,       path, "matlab"):
generate::Simscape     := loadproc(generate::Simscape,     path, "simscape"):
generate::CF           := loadproc(generate::CF,           path, "CF"):
generate::lisp         := loadproc(generate::lisp,         path, "lisp"):
generate::maple        := loadproc(generate::maple,        path, "maple"):
generate::mathematica  := loadproc(generate::mathematica,  path, "mma"):
generate::optimize     := loadproc(generate::optimize,     path, "optimize" ):
generate::splitProduct := loadproc(generate::splitProduct, path, "splprod"):
generate::hasNormalForm:= loadproc(generate::hasNormalForm,path, "splprod"):
generate::sortSum      := loadproc(generate::sortSum,      path, "sortsum"):
generate::sortSums     := loadproc(generate::sortSums,     path, "sortsum"):
generate::isNeg        := loadproc(generate::isNeg,        path, "sortsum"):
generate::negate       := loadproc(generate::negate,       path, "sortsum"):
generate::sortExprWithDOrDiff
                       := loadproc(generate::sortExprWithDOrDiff, path, "sortsum"):

prog::setcheckglobals(generate, {_domainOutputMode}):
null():

// end of file 
