
//
//   bij - 1998/99
//   
//   Pattern matching
//
//

matchlib:=newDomain("matchlib"):
matchlib::create_dom:=hold(matchlib):
matchlib::info:= "Library 'matchlib': tools for pattern matching":

matchlib::interface:= {}:

alias(path = pathname("MATCHLIB")):

matchlib::analyze:= () -> error("matchlib::analyze has been removed. Use prog::exprtree instead."):

matchlib::compile :=    loadproc(matchlib::compile,    path, "compile"):
matchlib::lazy_and_is_subs:= loadproc(matchlib::lazy_and_is_subs, path,
                                      "PrefixTree"):
matchlib::PrefixTree := loadproc(matchlib::PrefixTree, path, "PrefixTree"):
matchlib::PrefixTreeResult
		     := loadproc(matchlib::PrefixTreeResult,
				                       path, "PrefixTree"):
matchlib::PrefixTreeFixatedResults
		     := loadproc(matchlib::PrefixTreeFixatedResults,
				                       path, "PrefixTree"):
matchlib::PrefixTreeReplacement
		     := loadproc(matchlib::PrefixTreeReplacement,
				                       path, "PrefixTree"):
matchlib::evalFSA    := loadproc(matchlib::evalFSA,    path, "PrefixTree"):

matchlib::AC:= table(hold(_or)        = FALSE,
		     hold(_and)       = TRUE,
		     hold(_union)     = {},
		     hold(_intersect) = universe,
		     hold(_plus)      = 0,
		     hold(_mult)      = 1,
		     hold(_concat)    = null(),
		     hold(_fconcat)   = id):

matchlib::_remainders_to_vars := loadproc(matchlib::_remainders_to_vars,
					  path, "ACutils"):
matchlib::_construct_AC_solutions := loadproc(matchlib::_construct_AC_solutions,
					      path, "ACutils"):
matchlib::_orderedMultisetPartitions:=
loadproc(matchlib::_orderedMultisetPartitions, path, "ACutils"):

// utility functions for matching code
matchlib::solve_bipartite := loadproc(matchlib::solve_bipartite, path, "bipartite"):

matchlib::find_one_maximum_matching := loadproc(matchlib::find_one_maximum_matching,
						path, "bipartite"):
matchlib::enum_maximum_matching := loadproc(matchlib::enum_maximum_matching,
					    path, "bipartite"):
matchlib::all_rhs_combos := loadproc(matchlib::all_rhs_combos,
				     path, "bipartite"):

matchlib::block := loadproc(matchlib::block, path, "block"):
matchlib::unblock := loadproc(matchlib::unblock, path, "block"):
matchlib::isBlock := loadproc(matchlib::isBlock, path, "block"):


// internal routine for the addpattern functions
autoload(matchlib::addpatterns):


autoload(matchlib::einwohner):

prog::setcheckglobals(matchlib, {_X} ):

null():
