//  map Out::new instead of Out because strange behaviour of map (Content(hold(2^2*3))) 
_mult_intern::Content := (Out, data) -> Out::Capply(Out::Ctimes, map(op(data), Out::new));

_mult::Content :=
proc(Out, data)
  local value, numerator, denum, result, mapfunc;
begin
  mapfunc := proc(x)
               local xType;
             begin
               xType := FAIL;
               traperror((xType := type(x)));
               if xType=DOM_FLOAT or xType=DOM_COMPLEX then
                 x := Out(x);
                 if Out::typString(x)="plus" and
                   nops(x)=1 and
                   Out::attributString(x)="Signs=\"-\"" then
                   x := op(x);
                   value[1] := -value[1];
                 end_if;
                 if Out::typString(x)="times" then
                   x := op(x);
                 end_if;
                 x
               else
                 Out(x)
               end_if
             end_proc;
  
  value := generate::splitProduct(data, TRUE);

  if op(value, 1) <> -1 and
    nops(op(value, 2)) <= 1 and
    nops(op(value, 3)) = 0 and
    value[4] = [] and value[5] = [] then
    return(Out::stdFunc(data));
  end_if;
  
  if nops(op(value, 2)) = 1 then
    numerator := Out(op(op(value, 2)));
  else
    numerator := map(value[2], mapfunc);
    numerator := Out::Capply(Out::Ctimes, op(numerator));
  end_if;
  if op(value, 3) = [] then
    result := numerator;
  else
    if nops(op(value, 3)) = 1 then
      denum := Out(op(op(value, 3)));
    else
      denum := map(value[3], mapfunc);
      denum := Out::Capply(Out::Ctimes, op(denum));
    end_if;
  
    result := Out::Capply(Out::Cdivide, numerator, denum);
  end_if;

  if nops(value) > 3 and (value[4] <> [] or value[5] <> []) then
    // there were units
    if value[4] <> [] then
      if nops(value[4]) > 1 then
        numerator := Out(_mult_intern(op(value[4])))
      else
        numerator := Out(op(value[4]))
      end_if
    else
      numerator := Out(1)
    end_if;
    if value[5] <> [] then 
      if nops(value[5]) > 1 then
        denum :=  Out(_mult_intern(op(value[5])))
      else
        denum := Out(op(value[5]))
      end_if;
      
      result := Out::Capply(Out::Ctimes, result, 
                  Out::Capply(Out::Cdivide, numerator, denum))
    else
      // if result and numerator are products, flatten them
      if Out::typString(result)="times" then
        result := op(result)
      end_if;
      if Out::typString(numerator)="times" then
        numerator := op(numerator)
      end_if;
      result := Out::Capply(Out::Ctimes, result, numerator)
    end_if;
  end_if;

  if op(value, 1) = -1 then
    result := Out::Capply(Out::Cminus,  result);
  end_if;

  result
end_proc:
