Simplify::intPowHasLog:=
proc(e: "_power")
local a, b, q, br, t, bas, expo, c, i;
begin
[a, b] := [op(e)];
assert(type(a) = DOM_INT);

q:= numlib::ispower(a);      
      // handle log-cases first
      if type(b) = "log" then
        br:= [b];
        t:= 1
      elif type(b) = "_mult" then
        [br, t, c]:= split([op(b)], testtype, "log");
        t:= _mult(op(t))
      else
        br:= [];
        t:= b
      end_if;
      // now b = t*_mult(op(br))
      if br <> [] then
        // some logarithms have occurred
        if q<>FALSE then
          bas:= op(q, 1);
          expo:= op(q, 2)
        else
          bas:= a;
          expo:= 1
        end_if;
        // now a = bas^expo
        // find logarithms to base bas
        if (i:= contains(map(br, op, 1), bas)) > 0 then
          c:= br[i];
          delete br[i];
          // a^b = (bas^expo)^(c*op(br)*t)
          //     = bas^(c*op(br)*t*expo)
          //     = (bas^c)^(op(br) * t* expo)
          // since c = log(base, ...), bas^c = op(c, 2)
          return(op(c, 2)^ _mult(op(br), t, expo))
        end_if
      end_if;

e

end_proc: