
/*
solvelib::avoidAliasProblem(S, vars)

replace all bound identifiers in S by such that do not belong to vars

*/


solvelib::avoidAliasProblem:=
proc(S, vars: DOM_SET)
  local f, i: DOM_INT;
begin
  if vars = {} then
    return(S)
  end_if;
  
  if S::dom::avoidAliasProblem <> FAIL then
    return(S::dom::avoidAliasProblem(args()))
  end_if;

  if domtype((f:= eval(op(S, 0)))) = DOM_FUNC_ENV and
    (f:= f::avoidAliasProblem) <> FAIL then
    return(f(args()))
  end_if;
  
  if contains({DOM_LIST, DOM_SET}, domtype(S)) then
    return(map(S, solvelib::avoidAliasProblem, args(2..args(0))))
  end_if;

  if domtype(S) = DOM_EXPR and has(S, vars) then
    return(subsop(S,
                  (i= solvelib::avoidAliasProblem(op(S, i), args(2..args(0))))
                  $i=1..nops(S),
                  Unsimplified))
  end_if;
  
// default
  S
end_proc:
