

solvelib::expandTrig:=
proc(sys, unk: DOM_LIST)
  local mycosexpand, mysinexpand;
begin
  
    // expand sin, cos etc.
  mycosexpand:= 
  proc(a)
    local X, x, y, n, dummy, i;
  begin
    if type(a) <> "cos" then
      return(a)
    end_if;  
    
    X:= op(a, 1);
    if not has(X, unk) then return(a) end_if;
    
    if type(X) = "_plus" then
      [x, y, dummy]:= split(X, has, unk);
      if not iszero(y) then
        return(mycosexpand(cos(x))* cos(y) - mysinexpand(sin(x))* sin(y)) 
      else 
        x := _plus(op(a, [1, i]) $ i = 1 .. nops(op(a, 1)) div 2);
        y := _plus(op(a, [1, i]) $ i = (nops(op(a, 1)) div 2) + 1 .. nops(op(a, 1)));
        return(mycosexpand(cos(x))*mycosexpand(cos(y)) - mysinexpand(sin(x))*mysinexpand(sin(y))) 
      end_if;
    elif type(X) = "_mult" and type((n:= op(X, nops(X)))) = DOM_INT and abs(n) <= 10 then 
      return(cos::expand(a))
    end_if;
    a
  end_proc;
  
  
  mysinexpand:= 
  proc(a)
    local X, x, y, n, dummy, i;
  begin
    if type(a) <> "sin" then
      if type(-a) = "sin" then
        return(-mysinexpand(-a))
      else
        return(a)
      end_if
    end_if;  
    
    X:= op(a, 1);
    if not has(X, unk) then return(a) end_if;
    
    if type(X) = "_plus" then
      [x, y, dummy]:= split(X, has, unk);
      if not iszero(y) then
        return(mycosexpand(cos(x))* sin(y) + mysinexpand(sin(x))* cos(y)) 
      else 
        x := _plus(op(a, [1, i]) $ i = 1 .. nops(op(a, 1)) div 2);
        y := _plus(op(a, [1, i]) $ i = (nops(op(a, 1)) div 2) + 1 .. nops(op(a, 1)));
        return(mycosexpand(cos(x))*mysinexpand(sin(y)) + mysinexpand(sin(x))*mycosexpand(cos(y))) 
      end_if;
    elif type(X) = "_mult" and type((n:= op(X, nops(X)))) = DOM_INT and abs(n) <= 10 then 
      return(sin::expand(a))
    end_if;
    a
  end_proc;  
  

  misc::maprec(sys, {"sin"} = mysinexpand, {"cos"} = mycosexpand, {"exp"} = expand)
 
  
end_proc:
// end of file

  
  
  
  