//       

/*--
usage:
concatRow(s1, s2, ...)

concats two or more samples using their rows.
rows have to be of same length.
--*/
/*--
parameters:
s1  stats::sample (or list)
s2  stats::sample (or list) (all further samples or lists are optional)
--*/

stats::concatRow := proc()
begin
  if testargs() then
    if args(0) < 1 then
       error("Expecting at least one argument"):
    end_if:
    if has(map([args()], proc() begin ( 
              if not(domtype(args(1)) = stats::sample 
                  or domtype(args(1)) = DOM_LIST) then 
                FALSE 
              end_if ) end_proc ), FALSE)
    then
      error("All arguments must be of type stats::sample or DOM_LIST")
    end_if
  end_if;

  if args(0) = 1 then
     return(args(1));
  end_if;

  (stats::sample)::_concat(args())
end_proc:


// end of file 
 
