//    

/*--
	Ei/diff -- the function attribut "diff" for Ei
--*/

Ei::diff := proc(Eix)
local i, n, x;
begin
    if nops(Eix) = 1 then // Eix = Ei(x)
      x := op(Eix, 1);
      if args(0) = 1 then 
        return(hold(Ei)(x));
      elif has(x,args(2)) then
        if args(0) > 2 then
          return(diff(exp(x)/x,args(i) $ i=3..args(0)));
        else
          return(exp(x)/x*diff(x,args(2)));
        end_if
      else
         return(0);
      end_if;
   else //Eix = Ei(n, x)
      n:= op(Eix, 1);
      x:= op(Eix, 2);
      if args(0) = 1 then
        return(hold(Ei)(n, x));
      elif has(x,args(2)) or has(n, args(2)) then
        if iszero(n) then
           return(diff(exp(-x)/x, args(2..args(0))));
        end_if:
       
        if args(0) = 2 then
           if not has(n, args(2)) then
             return(-Ei(n-1, x)*diff(x,args(2)))
           else
             return(-Ei(n-1, x)*diff(x,args(2))
                    -( 1/(n-1)^2*hypergeom([-n+1, -n+1],[2-n, 2-n],-x)
                      +PI/sin(PI*n)*(PI*cot(PI*n)+psi(n)-ln(x))/gamma(n)*x^(n-1)
                     )*diff(n, args(2))
                  );
           end_if:
        else
           if not has(n, args(2)) then
             return(diff(-Ei(n-1, x)*diff(x, args(2)),args(i) $ i=3..args(0)));
           else
             return(diff(
                    -Ei(n-1, x)*diff(x,args(2))
                    -( 1/(n-1)^2/hypergeom([-n+1, -n+1],[2-n, 2-n],-x)
                      +PI/sin(PI*n)*(PI*cot(PI*n)+psi(n)-ln(x))/gamma(n)*x^(n-1)
                     )*diff(n, args(2)),
                    args(i) $ i=3..args(0))
                  );
            end_if:
        end_if;
      else
        return(0);
      end_if;
  end_if:
end_proc:

// end of file 
