//    

/*++

	unuse - the converse of use

	unuse(dm [,f1,...])

	dm      -   library domain
	f1, ... (optional) functions of dm
++*/

unuse:= proc(dm) 
   option hold, noDebug;
   local ver, unex;
begin 
   if args(0) < 1 then
     error("expecting at least 1 argument");
   end_if:
   dm := context(dm);
   ver:=slot(dm,"_exported");
   if domtype(ver) = DOM_FAIL then 
	return(null())
   elif args(0) = 1 then
	map(ver,sysdelete); 
	map(ver,protected, None); 
	sysdelete(slot(dm,"_exported"));
   else
	unex:= {args(2..args(0))};
	ver:= ver minus unex;
	map(unex,sysdelete);
	map(unex,protected, None); 
	if ver={} then
            sysdelete(slot(dm,"_exported"));
	else
	    sysassign(slot(dm,"_exported"), ver);
	end_if;
   end_if;
   
   null()
end_proc:

